%global glib2_version 2.66.0
%global gobject_introspection_version 1.66.0
%global mozjs102_version 102.5.0

Name:          gjs
Version:       1.75.1
Release:       2
Summary:       using GNOME libraries from Javascript
License:       MIT and (MPLv1.1 or GPLv2+ or LGPLv2+)
URL:           https://wiki.gnome.org/Projects/Gjs
Source0:       https://download.gnome.org/sources/%{name}/1.75/%{name}-%{version}.tar.xz
Patch0:        disable_tests-error.patch
#https://github.com/GNOME/gjs/commit/2079e0ed
Patch1:        Put-testGtk4.js-in-dbus-suite.patch

BuildRequires:  gcc-c++
BuildRequires:  meson
BuildRequires:  gettext
BuildRequires:  readline-devel
BuildRequires:  pkgconfig(cairo-gobject)
BuildRequires:  pkgconfig(gio-2.0) >= %{glib2_version}
BuildRequires:  pkgconfig(gobject-introspection-1.0) >= %{gobject_introspection_version}
BuildRequires:  pkgconfig(gtk4)
BuildRequires:  pkgconfig(mozjs-102) >= %{mozjs102_version}
BuildRequires:  pkgconfig(sysprof-capture-4)
BuildRequires:  dbus-daemon
# For GTK+ 3 tests
BuildRequires:  gtk3
# For dbus tests
BuildRequires:  dbus-glib-devel
# xvfb for test suite
BuildRequires:  xorg-x11-server-Xvfb

Requires: glib2%{?_isa} >= %{glib2_version}
Requires: gobject-introspection%{?_isa} >= %{gobject_introspection_version}
Requires: mozjs102%{?_isa} >= %{mozjs102_version}


# Filter provides for private libraries
#%%global __provides_exclude_from ^%{_libdir}/gjs/

%description
Gjs is a Javascript binding for GNOME. It's mainly based on Spidermonkey javascript
engine and the GObject introspection framework.

%package devel
Summary:      Development files for gjs
Requires:     %{name}%{?_isa} = %{version}-%{release}
Provides:     %{name}-tests = %{version}-%{release}
Obsoletes:    %{name}-tests < %{version}-%{release}

%description devel
Development files for gjs.

%prep
%autosetup -p1

%build
%meson
%meson_build

%install
%meson_install

%check
%{shrink:xvfb-run -s "-screen 0 1600x1200x24" %meson_test --timeout-multiplier=5}

%files
%defattr(-,root,root)
%doc NEWS README.md
%license COPYING
%{_bindir}/gjs*
%{_libdir}/*.so.*
%{_libdir}/gjs

%files devel
%defattr(-,root,root)
%doc examples/*
%{_includedir}/gjs-1.0
%{_libdir}/pkgconfig/gjs-1.0.pc
%{_libdir}/*.so
%{_libexecdir}/installed-tests
%{_datadir}/gjs-1.0/lsan/
%{_datadir}/gjs-1.0/valgrind/
%{_datadir}/installed-tests
%{_datadir}/glib-2.0/schemas/org.gnome.GjsTest.gschema.xml

%changelog
* Wed Feb 21 2024 liyanan <liyanan61@h-partners.com> - 1.75.1-2
- Put testGtk4.js in dbus suite

* Mon Jan 2 2023 lin zhang <lin.zhang@turbolinux.com.cn> - 1.75.1-1
- Upgrade to 1.75.1

* Wed Apr 06 2022 wangkai <wangkai385@huawei.com> - 1.71.1-1
- Update to 1.71.1

* Mon May 31 2021 weijin deng <weijin.deng@turbolinux.com.cn> - 1.66.2-1
- Upgrade to 1.66.2

* Fri Nov 13 2020 chengguipeng <chengguipeng1@huawei.com> - 1.66.1-1
- update to 1.66.1

* Fri Oct 9 2020 jinzhimin <jinzhimin2@huawei.com> - 1.65.4-1
- update to 1.65.4

* Mon Jan 20 2020 openEuler Buildteam <buildteam@openeuler.org> - 1.54.1-5
- Type:bugfix
- Id:NA
- SUG:NA
- DESC:add dbus-daemon in buildrequires

* Tue Dec 24 2019 openEuler Buildteam <buildteam@openeuler.org> - 1.54.1-4
- change the path of files

* Wed Sep 11 2019 Lijin Yang <yanglijin@huawei.com> - 1.54.1-3
- Package init
